# TODO:
# - pldize ha_logd initscript (look heartbeat.init?)
# - stonith-libs? pils? (any sense? libs are small and have little external dependencies)
# - separate some stonith plugins which have external dependencies?
#
# Conditional build:
%bcond_with	systemd	# systemd
%bcond_with	vacm	# VACM stonith plugin
#
Summary:	Reusable cluster components
Summary(pl.UTF-8):	Komponenty klastrowe wielokrotnego użytku
Name:		cluster-glue
Version:	1.0.12
Release:	6%{?tld}
License:	GPL v2+ and LGPL v2+
Group:		Aplications/System
# for future releases:
#Source0Download: https://github.com/ClusterLabs/cluster-glue/releases
#Source0:	https://github.com/ClusterLabs/cluster-glue/archive/%{version}/glue-%{version}.tar.gz
Source0:	http://hg.linux-ha.org/glue/archive/glue-%{version}.tar.bz2
# Source0-md5:	ec620466d6f23affa3b074b72bca7870
Patch0:		%{name}-link.patch
Patch1:		%{name}-opt.patch
Patch2:		%{name}-rc.patch
Patch3:		%{name}-heartbeat-libexecdir.patch
Patch4:		x32-long-long-time-types.patch
URL:		http://www.linux-ha.org/wiki/Cluster_Glue
BuildRequires:	OpenIPMI-devel >= 1.4
BuildRequires:	asciidoc
BuildRequires:	autoconf >= 2.53
BuildRequires:	automake
BuildRequires:	bzip2-devel
BuildRequires:	curl-devel
BuildRequires:	docbook-dtd42-xml
BuildRequires:	docbook-dtd44-xml
BuildRequires:	docbook-style-xsl
BuildRequires:	glib2-devel >= 2.0
BuildRequires:	help2man
BuildRequires:	libaio-devel
BuildRequires:	libltdl-devel
BuildRequires:	libnet-devel >= 1.0
BuildRequires:	libstdc++-devel
BuildRequires:	libtool
BuildRequires:	libuuid-devel
BuildRequires:	libxml2-devel >= 2.0
BuildRequires:	libxslt-progs
BuildRequires:	ncurses-devel
BuildRequires:	net-snmp-devel >= 5.4
BuildRequires:	openhpi-devel
BuildRequires:	openssl-devel
BuildRequires:	perl-tools-pod
BuildRequires:	pkgconfig
BuildRequires:	python3-devel
BuildRequires:	rpm-pythonprov
%{?with_vacm:BuildRequires:	vacm-devel}
BuildRequires:	zlib-devel
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires(post,preun,postun):	systemd-units
Requires:	systemd-units
Requires:	%{name}-libs = %{version}-%{release}
Requires:	perl-TimeDate
Requires:	rc-scripts
Provides:	group(haclient)
Provides:	user(hacluster)
# Directives to allow upgrade from combined heartbeat packages
Provides:	heartbeat-pils = 3.0.0-1
Obsoletes:	heartbeat-common
Obsoletes:	heartbeat-pils < 3.0.0-1
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
A collection of common tools that are useful for writing cluster
managers such as Pacemaker. Provides a local resource manager that
understands the OCF and LSB standards, and an interface to common
STONITH devices.

%description -l pl.UTF-8
Zbiór wspólnych narzędzi przydatnych przy pisaniu zarządców klastrów,
takich jak Pacemaker. Pakiet zawiera zarządcę zasobów lokalnych
zgodnego ze standardami OCF i LSB oraz interfejs do wspólnych urządzeń
STONITH.

%package libs
Summary:	Reusable cluster libraries
Summary(pl.UTF-8):	Biblioteki klastrowe wielokrotnego użytku
Group:		Libraries
Obsoletes:	libheartbeat2

%description libs
A collection of libraries that are useful for writing cluster managers
such as Pacemaker.

%description libs -l pl.UTF-8
Zbiór bibliotek przydatnych przy pisaniu zarządców klastrów, takich
jak Pacemaker.

%package libs-devel
Summary:	Header files for writing cluster managers
Summary(pl.UTF-8):	Pliki nagłówkowe do pisania zarządców klastrów
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	glib2-devel >= 2.0
Requires:	libltdl-devel
Obsoletes:	libheartbeat-devel

%description libs-devel
Header files useful for writing cluster managers such as Pacemaker.

%description libs-devel -l pl.UTF-8
Pliki nagłówkowe przydatne przy pisaniu zarządców klastrów, takich jak
Pacemaker.

%package tests
Summary:	Tests for cluster-glue framework
Summary(pl.UTF-8):	Testy dla szkieletu cluster-glue
Group:		Development
Requires:	%{name}-libs = %{version}-%{release}

%description tests
Tests for cluster-glue framework.

%description tests -l pl.UTF-8
Testy dla szkieletu cluster-glue.

%package stonith
Summary:	Provides an interface to Shoot The Other Node In The Head
Summary(pl.UTF-8):	Interfejs do "odstrzelenia" drugiego węzła w klastrze
Group:		Applications/System
Requires:	OpenIPMI >= 2.0.3
Provides:	heartbeat-stonith = 3.0.0-1
Obsoletes:	heartbeat-stonith < 3.0.0-1

%description stonith
Provides an interface to Shoot The Other Node In The Head.

%description stonith -l pl.UTF-8
STONITH (Shoot The Other Node In The Head) to interfejs służący do
"odstrzelenia" drugiego węzła w klastrze.

%prep
%setup -q -n Reusable-Cluster-Components-glue--glue-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%ifarch x32
%patch4 -p1
%endif

%{__sed} -i -e '1{
	s,^#!.*python$,#!%{__python3},
	s,^#!.*bin/env perl,#!%{__perl},
}' \
	lib/plugins/stonith/external/*

%build
%{__libtoolize}
%{__aclocal}
%{__autoheader}
%{__automake}
%{__autoconf}
CPPFLAGS="%{rpmcppflags} -DOPENIPMI_DEFINE_SELECTOR_T"
%configure \
	PYTHON=%{__python3} \
	--docdir=%{_docdir}/%{name}-%{version} \
	--disable-fatal-warnings \
	--disable-static \
	--enable-ipmilan \
	--with-daemon-group=haclient \
	--with-daemon-user=hacluster \
	--with-initdir=/etc/rc.d/init.d \
	--with-rundir=/var/run
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{systemdunitdir}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

find $RPM_BUILD_ROOT -name '*.la' -delete

%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 60 haclient
%useradd -u 17 -d /var/lib/heartbeat/cores/hacluster -c "Heartbeat User" -g haclient hacluster

%post
/sbin/chkconfig --add logd
%service logd restart
%systemd_post logd.service

%preun
if [ "$1" = "0" ]; then
	%service -q logd stop
	/sbin/chkconfig --del logd
fi
%systemd_preun logd.service

%postun
if [ "$1" = "0" ]; then
	%userremove hacluster
	%groupremove haclient
fi
%systemd_reload

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%exclude_systemd_files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog logd/logd.cf doc/stonith/README*
%attr(754,root,root) /etc/rc.d/init.d/logd
%if %{with systemd}
%{systemdunitdir}/logd.service
%endif

%attr(755,root,root) %{_sbindir}/ha_logger
%attr(755,root,root) %{_sbindir}/hb_report
%attr(755,root,root) %{_sbindir}/lrmadmin
%attr(755,root,root) %{_sbindir}/meatclient
%attr(755,root,root) %{_sbindir}/cibsecret
%{_mandir}/man1/ha_logger.1*
%{_mandir}/man8/ha_logd.8*
%{_mandir}/man8/hb_report.8*
%{_mandir}/man8/lrmadmin.8*
%{_mandir}/man8/meatclient.8*

%dir %{_datadir}/%{name}
%attr(755,root,root) %{_datadir}/%{name}/ha_cf_support.sh
%attr(755,root,root) %{_datadir}/%{name}/openais_conf_support.sh
%attr(755,root,root) %{_datadir}/%{name}/utillib.sh
%attr(755,root,root) %{_datadir}/%{name}/ha_log.sh

%attr(755,root,root) %{_libexecdir}/heartbeat/ha_logd
%attr(755,root,root) %{_libexecdir}/heartbeat/lrmd

%dir %{_libdir}/heartbeat/plugins/InterfaceMgr
%attr(755,root,root) %{_libdir}/heartbeat/plugins/InterfaceMgr/generic.so
%dir %{_libdir}/heartbeat/plugins/RAExec
%attr(755,root,root) %{_libdir}/heartbeat/plugins/RAExec/heartbeat.so
%attr(755,root,root) %{_libdir}/heartbeat/plugins/RAExec/lsb.so
%attr(755,root,root) %{_libdir}/heartbeat/plugins/RAExec/ocf.so
%dir %{_libdir}/heartbeat/plugins/compress
%attr(755,root,root) %{_libdir}/heartbeat/plugins/compress/bz2.so
%attr(755,root,root) %{_libdir}/heartbeat/plugins/compress/zlib.so

%dir /var/lib/heartbeat
%attr(711,root,root) %dir /var/lib/heartbeat/cores
%attr(700,root,root) %dir /var/lib/heartbeat/cores/root
%attr(700,hacluster,root) %dir /var/lib/heartbeat/cores/hacluster
# we don't want any files owned by nobody
%attr(700,root,root) %dir /var/lib/heartbeat/cores/nobody

%files libs
%exclude_systemd_files
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/liblrm.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblrm.so.2
%attr(755,root,root) %{_libdir}/libpils.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpils.so.2
%attr(755,root,root) %{_libdir}/libplumb.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libplumb.so.2
%attr(755,root,root) %{_libdir}/libplumbgpl.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libplumbgpl.so.2
%attr(755,root,root) %{_libdir}/libstonith.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libstonith.so.1
%dir %{_libdir}/heartbeat
%dir %{_libdir}/heartbeat/plugins
# also used by resource-agents runtime package (shouldn't agent_config.h be in resource-agents-devel?)
%dir %{_includedir}/heartbeat

%files libs-devel
%exclude_systemd_files
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/liblrm.so
%attr(755,root,root) %{_libdir}/libpils.so
%attr(755,root,root) %{_libdir}/libplumb.so
%attr(755,root,root) %{_libdir}/libplumbgpl.so
%attr(755,root,root) %{_libdir}/libstonith.so
%{_includedir}/clplumbing
%{_includedir}/heartbeat/compress.h
%{_includedir}/heartbeat/glue_config.h
%{_includedir}/heartbeat/ha_msg.h
%{_includedir}/heartbeat/lrm
%{_includedir}/stonith
%{_includedir}/pils

%files tests
%exclude_systemd_files
%defattr(644,root,root,755)
%attr(755,root,root) %{_libexecdir}/heartbeat/ipctest
%attr(755,root,root) %{_libexecdir}/heartbeat/ipctransientclient
%attr(755,root,root) %{_libexecdir}/heartbeat/ipctransientserver
%attr(755,root,root) %{_libexecdir}/heartbeat/transient-test.sh
%attr(755,root,root) %{_libexecdir}/heartbeat/base64_md5_test
%attr(755,root,root) %{_libexecdir}/heartbeat/logtest

%dir %{_libdir}/heartbeat/plugins/test
%attr(755,root,root) %{_libdir}/heartbeat/plugins/test/test.so

%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/lrmtest
%{_datadir}/%{name}/lrmtest/README.regression
%{_datadir}/%{name}/lrmtest/defaults
%{_datadir}/%{name}/lrmtest/descriptions
%{_datadir}/%{name}/lrmtest/language
%{_datadir}/%{name}/lrmtest/lrmadmin-interface
%attr(755,root,root) %{_datadir}/%{name}/lrmtest/LRMBasicSanityCheck
%attr(755,root,root) %{_datadir}/%{name}/lrmtest/lrmregtest*
%attr(755,root,root) %{_datadir}/%{name}/lrmtest/*.sh

%dir %{_datadir}/%{name}/lrmtest/testcases
%{_datadir}/%{name}/lrmtest/testcases/BSC
%{_datadir}/%{name}/lrmtest/testcases/basicset
%{_datadir}/%{name}/lrmtest/testcases/metadata
%{_datadir}/%{name}/lrmtest/testcases/metadata.exp
%{_datadir}/%{name}/lrmtest/testcases/rscexec
%{_datadir}/%{name}/lrmtest/testcases/rscexec.exp
%{_datadir}/%{name}/lrmtest/testcases/rscmgmt
%{_datadir}/%{name}/lrmtest/testcases/rscmgmt.exp
%{_datadir}/%{name}/lrmtest/testcases/stonith
%{_datadir}/%{name}/lrmtest/testcases/stonith.exp
%attr(755,root,root) %{_datadir}/%{name}/lrmtest/testcases/*filter
%attr(755,root,root) %{_datadir}/%{name}/lrmtest/testcases/*.sh

%files stonith
%exclude_systemd_files
%defattr(644,root,root,755)
%doc doc/stonith/README*
%attr(755,root,root) %{_sbindir}/stonith
%{_mandir}/man8/stonith.8*
%dir %{_libdir}/stonith
%dir %{_libdir}/stonith/plugins
%dir %{_libdir}/stonith/plugins/external
%attr(755,root,root) %{_libdir}/stonith/plugins/external/*
%dir %{_libdir}/stonith/plugins/stonith2
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/apcmaster.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/apcmastersnmp.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/apcsmart.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/baytech.so
# R: openhpi
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/bladehpi.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/cyclades.so
# R: curl libxml2
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/drac3.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/external.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/ibmhmc.so
# R: OpenIPMI
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/ipmilan.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/meatware.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/null.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/nw_rpc100s.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/rcd_serial.so
# R: libxml2
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/rhcs.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/rps10.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/ssh.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/suicide.so
%if %{with vacm}
# R: vacm-libs
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/vacm.so
%endif
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/wti_mpc.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/wti_nps.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/ribcl.py
%attr(755,root,root) %{_libdir}/stonith/plugins/xen0-ha-dom0-stonith-helper
%changelog
* Thu Apr 25 2024 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/cluster-glue.git;a=log;h=master

* Thu Apr 25 2024 Marcin Krol <hawk@tld-linux.org> 2963a3f
- allow packaging on systems without systemd

* Thu Apr 25 2024 Marcin Krol <hawk@tld-linux.org> 97b0f55
- use python3 in build process, BR asciidoc

* Fri Sep 24 2021 Jan Rękorajski <baggins@pld-linux.org> 330360a
- rebuild with openssl 3.0.0

* Tue Oct 06 2020 Jakub Bogusz <qboosh@pld-linux.org> 5adce6c
- release 5 (net-snmp 5.9)

* Mon Oct 05 2020 Jan Palus <atler@pld-linux.org> 1466a1e
- fix shebangs

* Mon Oct 05 2020 Jan Rękorajski <baggins@pld-linux.org> deddd68
- release 4 (by relup.sh)

* Fri May 01 2020 Jakub Bogusz <qboosh@pld-linux.org> e9eb22e
- repo moved to github

* Fri May 01 2020 Jakub Bogusz <qboosh@pld-linux.org> d184d87
- updated URL

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 17955e9
- release 3 (by relup.sh)

* Sun Sep 02 2018 Jakub Bogusz <qboosh@pld-linux.org> d6a380f
- added heartbeat-libexecdir patch (use libexecdir for heartbeat daemons, for consistency with heartbeat and resource-agents packages)
- release 2

* Fri Dec 18 2015 Jakub Bogusz <qboosh@pld-linux.org> aed8382
- updated to 1.0.12
- updated opt patch
- added rc patch (install both SysV and systemd scripts; fix HA_VARRUNDIR in .service file)

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> 0495e60
- x32 rebuild
- release 8 (by relup.sh)

* Sun Jan 04 2015 Jan Rękorajski <baggins@pld-linux.org> 25b4383
- fix for time_t and clock_t being long long on x32

* Mon Dec 30 2013 Łukasz Kieś <kiesiu@pld-linux.org> 18d8987
- manually install stonith readme files
- rebuild with libgcrypt 1.6; rel. 7

* Wed Dec 25 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 9c1b683
- release 6 (by relup.sh)

* Fri Sep 06 2013 Jakub Bogusz <qboosh@pld-linux.org> 1be99b6
- added link patch (fixes linking of some plugins, avoid unnecessary libraries in global LIBS)
- added opt patch (avoid disabling all gcc optimizations with -O0)
- separated -tests

* Tue Sep 03 2013 Jakub Bogusz <qboosh@pld-linux.org> efb3674
- pl

* Thu Dec 06 2012 Jan Rękorajski <baggins@pld-linux.org> 4079e79
- release 5 (by relup.sh)

* Wed Nov 21 2012 Jan Rękorajski <baggins@pld-linux.org> 77838a0
- release 4 (by relup.sh)

* Fri Nov 09 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 1146040
- Release: 3

